From: Samuel Bronson <naesten@gmail.com>
To: gdb-patches@sourceware.org
Cc: Tom Tromey <tromey@redhat.com>,
Jan Kratochvil <jan.kratochvil@redhat.com>,
Doug Evans <dje@google.com>
Subject: [PATCH v3] Resurrect gdb-add-index as a contrib script
Date: Sat, 09 Nov 2013 18:41:00 -0000 [thread overview]
Message-ID: <E1Vf1xJ-0002Ya-T4@hydrogen> (raw)
In-Reply-To: <1383519137-26388-1-git-send-email-naesten@gmail.com>
This includes some changes made in Fedora's gdb packaging[1], and
Doug's robustness patch[2] from before it was dropped (with some
slight corrections).
[1]: http://pkgs.fedoraproject.org/cgit/gdb.git/log/gdb-gdb-add-index-script.patch?id=fe74423b0812bae6d7bb027584e401a2ac37d24d
[2]: https://sourceware.org/ml/gdb-patches/2010-09/msg00130.html
I'm including a log of relevant previous activity.
(I would just include committishes, but I'm not quite confident that
history won't be rewritten again, invalidating the hashes, plus there
are no relevant tags so the first two parts of git-describe(1) output
wouldn't be any help either.)
commit 97924a976b7d6e1669cf22c5fdf292a53bae6bd0
Author: Tom Tromey <tromey@redhat.com>
Date: Tue Nov 16 17:38:40 2010 +0000
* gdb-add-index.sh: Really remove.
gdb/ChangeLog | 4 ++++
gdb/gdb-add-index.sh | 29 -----------------------------
2 files changed, 4 insertions(+), 29 deletions(-)
commit c29c521f43a1f470355cc76391bb10ec2b73284a
Author: Tom Tromey <tromey@redhat.com>
Date: Tue Aug 10 18:35:53 2010 +0000
gdb
Revert gdb-add-index addition:
* Makefile.in (install-only): Don't install gdb-add-index.
* gdb-add-index.sh: Remove.
gdb/doc
Revert gdb-add-index addition:
* gdb.texinfo (Index Files): Don't document gdb-add-index.
gdb/ChangeLog | 6 ++++++
gdb/Makefile.in | 11 +----------
gdb/doc/ChangeLog | 5 +++++
gdb/doc/gdb.texinfo | 10 ----------
4 files changed, 12 insertions(+), 20 deletions(-)
commit c2bbed2a5ab3c5c5950ef192f9be610a11aaa367
Author: Tom Tromey <tromey@redhat.com>
Date: Fri Jul 30 20:46:34 2010 +0000
gdb
* Makefile.in (install-only): Install gdb-add-index.
* gdb-add-index.sh: New file.
gdb/doc
* gdb.texinfo (Index Files): Mention gdb-add-index.
gdb/ChangeLog | 5 +++++
gdb/Makefile.in | 11 ++++++++++-
gdb/doc/ChangeLog | 4 ++++
gdb/doc/gdb.texinfo | 9 +++++++++
gdb/gdb-add-index.sh | 29 +++++++++++++++++++++++++++++
5 files changed, 57 insertions(+), 1 deletion(-)
---
gdb/ChangeLog | 8 ++++++
gdb/contrib/gdb-add-index.sh | 61 ++++++++++++++++++++++++++++++++++++++++++++
2 files changed, 69 insertions(+)
create mode 100755 gdb/contrib/gdb-add-index.sh
diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 79abe3d..def36a3 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,11 @@
+2013-11-08 Tom Tromey <tromey@redhat.com>
+ Jan Kratochvil <jan.kratochvil@redhat.com>
+ Doug Evans <dje@google.com>
+ Samuel Bronson <naesten@gmail.com>
+
+ Bring back gdb-add-index as a contrib script.
+ * contrib/gdb-add-index.sh: New file.
+
2013-11-08 Doug Evans <dje@google.com>
* dwarf2read.c (dwarf2_read_debug): Change to unsigned int.
diff --git a/gdb/contrib/gdb-add-index.sh b/gdb/contrib/gdb-add-index.sh
new file mode 100755
index 0000000..437e8c4
--- /dev/null
+++ b/gdb/contrib/gdb-add-index.sh
@@ -0,0 +1,61 @@
+#! /bin/sh
+
+# Add a .gdb_index section to a file.
+
+# Copyright (C) 2010, 2012-2013 Free Software Foundation, Inc.
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# This program assumes gdb and objcopy are in $PATH.
+
+myname="${0##*/}"
+
+if test $# != 1; then
+ echo "usage: $myname FILE" 1>&2
+ exit 1
+fi
+
+file="$1"
+
+if test ! -r "$file"; then
+ echo "$myname: unable to access: $file" 1>&2
+ exit 1
+fi
+
+dir="${file%/*}"
+test "$dir" = "$file" && dir="."
+index="${file}.gdb-index"
+
+# Ensure intermediate index file is removed when we exit.
+trap "rm -f $index" 0
+
+gdb --batch-silent -nx -iex 'set auto-load no' \
+ -ex "file $file" -ex "save gdb-index $dir" || {
+ # Just in case.
+ status=$?
+ echo "$myname: gdb error generating index" 1>&2
+ exit $status
+}
+
+# In some situations gdb can exit without creating an index. This is
+# not an error.
+# E.g., if $file is stripped. This behaviour is akin to stripping an
+# already stripped binary, it's a no-op.
+
+if test -f "$index"; then
+ objcopy --add-section .gdb_index="$index" \
+ --set-section-flags .gdb_index=readonly "$file" "$file"
+ status=$?
+fi
+
+exit $status
--
1.8.4.rc3
next prev parent reply other threads:[~2013-11-09 6:23 UTC|newest]
Thread overview: 14+ messages / expand[flat|nested] mbox.gz Atom feed top
2013-11-03 22:52 [PATCH] " Samuel Bronson
2013-11-04 2:05 ` Samuel Bronson
2013-11-04 21:17 ` Samuel Bronson
2013-11-07 20:10 ` Jan Kratochvil
2013-11-07 21:54 ` Tom Tromey
2013-11-09 6:23 ` [PATCH v2] " Samuel Bronson
2013-11-09 18:41 ` Samuel Bronson [this message]
2013-11-11 19:46 ` [PATCH v3] " Doug Evans
2013-11-15 3:31 ` [PATCH v4] " Samuel Bronson
2013-11-15 10:50 ` Doug Evans
2013-11-15 15:27 ` Jan Kratochvil
2013-11-15 16:38 ` Eli Zaretskii
2013-11-15 22:00 ` [PATCH v5] " Samuel Bronson
2013-11-16 12:12 ` Jan Kratochvil
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=E1Vf1xJ-0002Ya-T4@hydrogen \
--to=naesten@gmail.com \
--cc=dje@google.com \
--cc=gdb-patches@sourceware.org \
--cc=jan.kratochvil@redhat.com \
--cc=tromey@redhat.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox